/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(_dereq_,module,exports){
'use strict';

Object.assign(mejs.MepDefaults, {
	markerColor: '#E9BC3D',

	markerWidth: 1,

	markers: [],
	
	markerSeek: false,
	
	markerStart: 0,

	markerCallback: function markerCallback() {}
});

Object.assign(MediaElementPlayer.prototype, {
	buildmarkers: function buildmarkers(player, controls, layers, media) {

		if (!player.options.markers.length) {
			return;
		}

		var t = this,
		    currentPos = -1,
		    currentMarker = -1,
		    lastPlayPos = -1,
		    lastMarkerCallBack = -1;

		for (var i = 0, total = player.options.markers.length; i < total; ++i) {
			var marker = document.createElement('span');
			marker.className = t.options.classPrefix + 'time-marker';
			controls.querySelector('.' + t.options.classPrefix + 'time-total').appendChild(marker);
		}

		media.addEventListener('durationchange', function () {
			console.log("Duration Change");
			//player.setmarkers(controls);
		});
		media.addEventListener('loadedmetadata', function(){
			player.setmarkers(controls);
			if(player.options.markerStart > 0){
				lastPlayPos = player.options.markers[player.options.markerStart - 1];
				media.currentTime = lastPlayPos;
				var elm = document.getElementById("quiz");
				elm.innerHTML = "<span>Video đang được phát tiếp từ điểm dừng lần trước...</span>";
				elm.classList.add("quiz-f");
				setTimeout(function() { elm.innerHTML = ""; elm.classList.remove("quiz-f") }, 8000);
			}
		});
		media.addEventListener('timeupdate', function () {
			currentPos = Math.floor(media.currentTime);
			if(player.options.markerSeek == "stop" && Math.abs(currentPos - lastPlayPos) > 2){
				//media.setCurrentTime(lastPlayPos);
				media.currentTime = lastPlayPos;
				currentPos = lastPlayPos;
				//media.pause();
			}
			else if(player.options.markerSeek == "stage"){
				var start = 0, end = 0;
				var total = player.options.markers.length;
				for(var i = 0; i < total; i++)
					if( player.options.markers[0] > lastPlayPos ){
						start = 0;
						end = player.options.markers[0];
						break;
					}
					else if(player.options.markers[i-1] < lastPlayPos && player.options.markers[i] > lastPlayPos){
						start = player.options.markers[i-1];
						end = player.options.markers[i];
						break;
					}
					else if(player.options.markers[total] < lastPlayPos){
						start = player.options.markers[total];
						end = media.duration;
						break;
					}
				if(start == end){

				}
				else if(currentPos > end){
					media.currentTime = end - 5;
					currentPos = end - 5;
				}
				/*
				else if(currentPos < start){
					media.currentTime = start + 1;
					currentPos = start + 1;
				}
				*/	
			}
			if (lastPlayPos > currentPos) {
				if (lastMarkerCallBack > currentPos) {
					lastMarkerCallBack = -1;
				}
			} else {
				lastPlayPos = currentPos;
			}

			if (player.options.markers.length) {
				for (var _i = 0, _total = player.options.markers.length; _i < _total; ++_i) {
					if(media.markerDone.indexOf(_i) > -1){ continue; }
					currentMarker = Math.floor(player.options.markers[_i]);
					if (currentPos === currentMarker && currentMarker !== lastMarkerCallBack) {
						media.pause();
						player.options.markerCallback(media, _i);
						lastMarkerCallBack = currentMarker;
					}
					var deltaTime = Math.floor(currentMarker - currentPos);
					if( (deltaTime <= 5) && (deltaTime > 0) ){
						//var elm = document.getElementById("quiz");
						//elm.innerHTML = "<span>Còn "+deltaTime+" giây nữa sẽ có câu hỏi...</span>";
						//elm.classList.add("quiz-f");
					}
				}
			}
		}, false);
	},
	setmarkers: function setmarkers(controls) {

		var t = this,
		    markers = controls.querySelectorAll('.' + t.options.classPrefix + 'time-marker');

		for (var i = 0, total = t.options.markers.length; i < total; ++i) {
			if (Math.floor(t.options.markers[i]) <= t.media.duration && Math.floor(t.options.markers[i]) >= 0) {
				var left = 100 * Math.floor(t.options.markers[i]) / t.media.duration,
				    marker = markers[i];

				marker.style.width = t.options.markerWidth + 'px';
				marker.style.left = left + '%';
				marker.style.background = t.options.markerColor;
			}
		}
	}
});

},{}]},{},[1]);
